<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/calAfe2sq.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>calAfe2sq.c</h1><a href="calAfe2sq_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: calAfe2sq.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="calAfe2sq_8c.html#a3c9e7dc062accf00d94cdd1e6124764d">00029</a> <span class="keywordtype">int</span> <a class="code" href="calAfe2sq_8c.html#a3c9e7dc062accf00d94cdd1e6124764d">findeleslice</a>(<span class="keywordtype">int</span> ln_ele,<span class="keywordtype">int</span> *elevert,PetscReal *vertxyz2,PetscReal zcut,<span class="keywordtype">int</span> *nele,<span class="keywordtype">int</span> *sliceele)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> rank,size;
<a name="l00035"></a>00035   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00036"></a>00036   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span> cnt=0;
<a name="l00039"></a>00039   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;ln_ele;i++) {
<a name="l00040"></a>00040     PetscReal sgn;
<a name="l00041"></a>00041     <span class="comment">/* get z-coordinate of first vertex */</span>
<a name="l00042"></a>00042     sgn=vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*elevert[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+2]-zcut;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00045"></a>00045       <span class="comment">/* multiply with other z-coordinate of other vertices</span>
<a name="l00046"></a>00046 <span class="comment">         if (product &lt; 0) then they have opposite signs and</span>
<a name="l00047"></a>00047 <span class="comment">         the element must be cut by the slice plane</span>
<a name="l00048"></a>00048 <span class="comment">      */</span>
<a name="l00049"></a>00049       <span class="keywordflow">if</span> (sgn*(vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*elevert[NV*i+j]+2]-zcut) &lt;= 0.0) {
<a name="l00050"></a>00050         <span class="comment">/* add its local index to the array */</span>
<a name="l00051"></a>00051         sliceele[cnt++]=i;
<a name="l00052"></a>00052         <span class="keywordflow">break</span>;
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00058"></a>00058     <span class="stringliteral">&quot;&lt;%i&gt;Found %i elements cut by slice plane\n&quot;</span>,
<a name="l00059"></a>00059     rank,cnt
<a name="l00060"></a>00060   );
<a name="l00061"></a>00061   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   *nele=cnt;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="util_8h.html#ad3e7b439709d947546efecaf99da3759">00068</a> <span class="keywordtype">int</span> <a class="code" href="calAfe2sq_8c.html#aa06eabdea2e391822f9b4f13e5ffc35e">CalAfe2sq</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,PetscReal *vertxyz2,PetscReal *bbox,<span class="keywordtype">int</span> *pix,<span class="keywordtype">int</span> slice_id,Mat *pAIpol)
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordtype">int</span> rank,size;
<a name="l00073"></a>00073   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00074"></a>00074   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00077"></a>00077     <span class="stringliteral">&quot;Calculating interpolation matrix fe-&gt;sq for volume with pid %i\n&quot;</span>
<a name="l00078"></a>00078     <span class="stringliteral">&quot;in bbox (%g,%g,%g) (%g,%g,%g) with %i x %i x %i pixels\n&quot;</span>,
<a name="l00079"></a>00079     slice_id+1,
<a name="l00080"></a>00080     bbox[0],bbox[1],bbox[2],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2],
<a name="l00081"></a>00081     pix[0],pix[1],pix[2]
<a name="l00082"></a>00082   );
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/* find elements which cut the slice plane</span>
<a name="l00085"></a>00085 <span class="comment">     (// to x-y plane: z=bbox[ND+2]-bbox[2])</span>
<a name="l00086"></a>00086 <span class="comment">  */</span>
<a name="l00087"></a>00087   <span class="keywordtype">int</span> *sliceele;
<a name="l00088"></a>00088   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;sliceele);CHKERRQ(ierr);
<a name="l00089"></a>00089   <span class="keywordtype">int</span> cnt;
<a name="l00090"></a>00090   ierr = <a class="code" href="calAfe2sq_8c.html#a3c9e7dc062accf00d94cdd1e6124764d">findeleslice</a>(gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,vertxyz2,(bbox[2]+bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2])/2.0,&amp;cnt,sliceele);CHKERRQ(ierr);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordtype">int</span> sum;
<a name="l00093"></a>00093   ierr=MPI_Allreduce((<span class="keywordtype">int</span>*)&amp;cnt,(<span class="keywordtype">int</span>*)&amp;sum,1,MPI_INT,MPI_SUM,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00094"></a>00094   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00095"></a>00095     <span class="stringliteral">&quot;Found total %i elements cut by slice plane.\n&quot;</span>,
<a name="l00096"></a>00096     sum
<a name="l00097"></a>00097   );
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (sum==0) {
<a name="l00100"></a>00100     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Slice plane outside the FE mesh.\n&quot;</span>);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     ierr = PetscFree(sliceele);CHKERRQ(ierr);
<a name="l00103"></a>00103     *pAIpol=PETSC_NULL;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00106"></a>00106   }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   Mat AIpol;
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (!rank) {
<a name="l00110"></a>00110     ierr = MatCreateMPIAIJ(
<a name="l00111"></a>00111       PETSC_COMM_WORLD,
<a name="l00112"></a>00112       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00113"></a>00113       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00114"></a>00114       2*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,2*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00115"></a>00115       &amp;AIpol
<a name="l00116"></a>00116     );CHKERRQ(ierr);
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118   <span class="keywordflow">else</span> {
<a name="l00119"></a>00119     ierr = MatCreateMPIAIJ(
<a name="l00120"></a>00120       PETSC_COMM_WORLD,
<a name="l00121"></a>00121       0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00122"></a>00122       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00123"></a>00123       <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00124"></a>00124       &amp;AIpol
<a name="l00125"></a>00125     );CHKERRQ(ierr);
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127   ierr = MatSetFromOptions(AIpol);CHKERRQ(ierr);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating interpolation matrix...\n&quot;</span>);
<a name="l00130"></a>00130   <span class="comment">/* loop over all elements, which are cut by the slice plane */</span>
<a name="l00131"></a>00131   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;cnt; k++) {
<a name="l00132"></a>00132     PetscReal elebox[2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00133"></a>00133     <span class="keywordtype">int</span>       pixbox[2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00134"></a>00134     <span class="keywordtype">int</span>       t_ele;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(k,cnt,10);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="comment">/* get current element id */</span>
<a name="l00139"></a>00139     t_ele=sliceele[k];
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="comment">/* check for requested property id</span>
<a name="l00142"></a>00142 <span class="comment">     * slice_id &gt;= 0:  only if pid==slice_id</span>
<a name="l00143"></a>00143 <span class="comment">     * slice_id == -1: any pid</span>
<a name="l00144"></a>00144 <span class="comment">     * slice_id &lt;= -2: only if pid!=slice_id</span>
<a name="l00145"></a>00145 <span class="comment">     */</span>
<a name="l00146"></a>00146     <span class="keywordflow">if</span> (slice_id&gt;=0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[t_ele]!=slice_id) <span class="keywordflow">continue</span>;
<a name="l00147"></a>00147     <span class="keywordflow">if</span> (slice_id&lt;=-2 &amp;&amp; gdata-&gt;eleprop[t_ele]==-slice_id-1) <span class="keywordflow">continue</span>;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="comment">/* find bbox around element */</span>
<a name="l00150"></a>00150     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00151"></a>00151       elebox[i]=PETSC_MAX;
<a name="l00152"></a>00152       elebox[ND+i]=PETSC_MIN;
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>; l++) {
<a name="l00155"></a>00155       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;ND;i++) {
<a name="l00156"></a>00156         elebox[i]=   PetscMin(elebox[i],   vertxyz2[ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+l]+i]);
<a name="l00157"></a>00157         elebox[ND+i]=PetscMax(elebox[ND+i],vertxyz2[ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+l]+i]);
<a name="l00158"></a>00158       }
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160     <span class="comment">/* check that bbox is valid */</span>
<a name="l00161"></a>00161     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;ND;i++) {
<a name="l00162"></a>00162       assert(elebox[ND+i]&gt;elebox[i]);
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     <span class="comment">/* find pixels in the elebox */</span>
<a name="l00166"></a>00166     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;ND;i++) {
<a name="l00167"></a>00167       pixbox[i]=   (int) floor(pix[i]*(elebox[   i]-bbox[i])/(bbox[ND+i]-bbox[i]));
<a name="l00168"></a>00168       pixbox[ND+i]=(int)  ceil(pix[i]*(elebox[ND+i]-bbox[i])/(bbox[ND+i]-bbox[i]));
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="comment">/* loop over pixels in pixbox */</span>
<a name="l00172"></a>00172     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=pixbox[0];i&lt;=pixbox[ND+0];i++) {
<a name="l00173"></a>00173       <span class="comment">/* check if we are outside the requested rectangle */</span>
<a name="l00174"></a>00174       <span class="keywordflow">if</span> (i&lt;0 || i&gt;=pix[0]) <span class="keywordflow">continue</span>;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=pixbox[1];j&lt;=pixbox[ND+1];j++) {
<a name="l00177"></a>00177         <span class="comment">/* check if we are outside the requested rectangle */</span>
<a name="l00178"></a>00178         <span class="keywordflow">if</span> (j&lt;0 || j&gt;=pix[1]) <span class="keywordflow">continue</span>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180         PetscReal p[ND],rhs[ND];
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         <span class="comment">/* calculate xyz coordinates of pixel</span>
<a name="l00183"></a>00183 <span class="comment">           NB: keep integers (i,pix[0]) separated by float</span>
<a name="l00184"></a>00184 <span class="comment">           otherwise division of integers always gives 0!</span>
<a name="l00185"></a>00185 <span class="comment">        */</span>
<a name="l00186"></a>00186         p[0]=bbox[0]+i*(bbox[ND+0]-bbox[0])/pix[0];
<a name="l00187"></a>00187         p[1]=bbox[1]+j*(bbox[ND+1]-bbox[1])/pix[1];
<a name="l00188"></a>00188         p[2]=(bbox[2]+bbox[ND+2])/2.0;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         <span class="keywordflow">if</span> (
<a name="l00191"></a>00191           <a class="code" href="barycent_8c.html#ac3e1493d687d06e1258e781a9fdf5a90">barycent</a>(
<a name="l00192"></a>00192             p,
<a name="l00193"></a>00193             vertxyz2+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+0],
<a name="l00194"></a>00194             vertxyz2+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+1],
<a name="l00195"></a>00195             vertxyz2+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+2],
<a name="l00196"></a>00196             vertxyz2+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+3],
<a name="l00197"></a>00197             rhs
<a name="l00198"></a>00198           )
<a name="l00199"></a>00199         ) {
<a name="l00200"></a>00200           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;ND;l++) {
<a name="l00201"></a>00201             PetscReal   matele;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203             matele=(1-rhs[0]-rhs[1]-rhs[2]);
<a name="l00204"></a>00204             ierr = MatSetValue(AIpol,
<a name="l00205"></a>00205               ND*(i*pix[1]+j)+l,
<a name="l00206"></a>00206               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+3]+l,
<a name="l00207"></a>00207             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209             matele=rhs[0];
<a name="l00210"></a>00210             ierr = MatSetValue(AIpol,
<a name="l00211"></a>00211               ND*(i*pix[1]+j)+l,
<a name="l00212"></a>00212               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+0]+l,
<a name="l00213"></a>00213             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215             matele=rhs[1];
<a name="l00216"></a>00216             ierr = MatSetValue(AIpol,
<a name="l00217"></a>00217               ND*(i*pix[1]+j)+l,
<a name="l00218"></a>00218               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+1]+l,
<a name="l00219"></a>00219             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221             matele=rhs[2];
<a name="l00222"></a>00222             ierr = MatSetValue(AIpol,
<a name="l00223"></a>00223               ND*(i*pix[1]+j)+l,
<a name="l00224"></a>00224               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*t_ele+2]+l,
<a name="l00225"></a>00225             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00226"></a>00226           }
<a name="l00227"></a>00227         }
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229     }
<a name="l00230"></a>00230   }
<a name="l00231"></a>00231   ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   ierr = PetscFree(sliceele);CHKERRQ(ierr);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   PetscInfo(0,<span class="stringliteral">&quot;AIpol matrix assembly complete\n&quot;</span>);
<a name="l00236"></a>00236   ierr = MatAssemblyBegin(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00237"></a>00237   ierr = MatAssemblyEnd(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00238"></a>00238   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(AIpol);CHKERRQ(ierr);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">/* check interpolation matrix */</span>
<a name="l00241"></a>00241   PetscReal area;
<a name="l00242"></a>00242   ierr = <a class="code" href="area_8c.html#ae10b3dfec502fed986fa89fea83631f9">AreaCal</a>(AIpol,&amp;area);CHKERRQ(ierr);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   *pAIpol=AIpol;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

